<?php

/*______________________________________________________________________________
 | Plugin SpipService 1.0 pour Spip 2.1                                           \
 | Copyright 2012 Sebastien Chandonay - Studio Lambda                            \
 |                                                                                |
 | SpipService est un logiciel libre : vous pouvez le redistribuer ou le          |
 | modifier selon les termes de la GNU General Public Licence tels que            |
 | publiés par la Free Software Foundation : à votre choix, soit la               |
 | version 3 de la licence, soit une version ultérieure quelle qu'elle            |
 | soit.                                                                          |
 |                                                                                |
 | SpipService est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE     |
 | GARANTIE ; sans même la garantie implicite de QUALITÉ MARCHANDE ou             |
 | D'ADÉQUATION À UNE UTILISATION PARTICULIÈRE. Pour plus de détails,             |
 | reportez-vous à la GNU General Public License.                                 |
 |                                                                                |
 | Vous devez avoir reçu une copie de la GNU General Public License               |
 | avec SpipService. Si ce n'est pas le cas, consultez                            |
 | <http://www.gnu.org/licenses/>                                                 |
 ________________________________________________________________________________*/

/* pour que le pipeline ne rale pas ! */
function spipservice_autoriser(){}

/*
 autoriser('creer', 'spipservice', null);
 => e la recherche des fonctions suivantes
 1 - autoriser_$type_$faire
 2 - autoriser_$type
 3 - autoriser_$faire

 $type  = 'spipservice' (forcement)
 $faire = 'spipservice_truc' (au lieu de 'truc' tout court (pb compatibilite avec acces restreint...)

 */

/* Documenter (joindre doc) */
function autoriser_spipservice_documenter($faire, $type, $id, $qui, $opt) {
	$type = $opt['type'];
	$id = $opt['id'];
	return autoriser('joindredocument', $type, $id);
}

/* Instituer */
function autoriser_spipservice_instituer($faire, $type, $id, $qui, $opt) {
	
	$type = $opt['type'];
	$id = $opt['id'];
	$statut = $opt['statut'];

	if (in_array($qui['statut'], array('0minirezo')) || $qui['webmestre']=='oui'){
		return true;
	}else{
		// test pour un statut particulier
		if ($statut){
			if (autoriser('modifier', $type, $id) && $statut!= 'publie' && $statut!= 'refuse' && $statut!= 'poubelle'){
				return true;
			}
		}
		// test general
		else{
			return autoriser('modifier', $type, $id);
		}
	}
	return false;
}

/* Voir */
function autoriser_spipservice_voir($faire, $type, $id, $qui, $opt) {
	$type = $opt['type'];
	$id = $opt['id'];
	return autoriser('voir', $type, $id);
}

// Creer
function autoriser_spipservice_creer($faire, $type, $id, $qui, $opt) {
	$type = $opt['type'];
	$id = $opt['id'];
	if (!$id) $id = 0;
	return autoriser('creer'.$type.'dans','rubrique',$id);
}

// Supprimer
function autoriser_spipservice_supprimer($faire, $type, $id, $qui, $opt) {
	$type = $opt['type'];
	$id = $opt['id'];
	if (in_array($qui['statut'], array('0minirezo')) || $qui['webmestre']=='oui'){
		if ($type == 'article'){
			return true;
		}else if ($type == 'breve'){
			return true;
		}else if ($type == 'rubrique'){
			// check si la rubrique a encore des articles fils dont le statut n'est pas 'poubelle'
			$res1 = sql_countsel("spip_articles", "id_rubrique=".$opt['id']." and (statut not like 'poubelle')");
			// check si la rubrique a encore des rubriques filles
			$res2 = sql_countsel("spip_rubriques", "id_parent=".$opt['id']);
			if ($res1==0 && $res2==0){
				return true;
			}
		}
	}
	return false;
}

// Modifier
function autoriser_spipservice_modifier($faire, $type, $id, $qui, $opt) {
	$type = $opt['type'];
	$id = $opt['id'];
	return autoriser('modifier', $type, $id);
}

// Iconifier
function autoriser_spipservice_iconifier($faire, $type, $id, $qui, $opt) {
	$type = $opt['type'];
	$id = $opt['id'];
	return autoriser('iconifier', $type, $id);
}

// Configurer (interface ecrire/)
function autoriser_spipservice_conf($faire, $type, $id, $qui, $opt) {
	return (in_array($qui['statut'], array('0minirezo')) || $qui['webmestre']=='oui');
}

?>
